/* this is a sas file to take the stacked data created in convert.do and run SAS on it to get LIML, 2sls second stage results */ 

/* .lst file is messy because I didn't take the time to omit all of the linear dependencies, i.e I have 4 city size dummies in regressions, but one of them is always linearly dependent. */

/*  SAs, unlike stata, expresses all these linear dependencies before running the regression; results match stata results so I won't bother actually cleaning up the output at this stage */

/* note that I read the crim_sas.dat file in compressed */

/* note also that this file produces a huge output file and takes hours to run  because the stacking of crime types leads to matrices that are enormous, and because a large number of variations are included */

/* this file contains estimates both with and without heterosckedasticity across crime categories, and with and without restrictions on whether all violent (property) crimes carry the same coefficient. */

/* Thus there are four sets of regressions output in this file per column shown in Table 3 of the paper, where i only report the heteroskedastic, parameter restricted results*/



filename rawdat1 pipe 'zcat crim_sas.dat.Z';
options compress=yes;

data pol_tem2;
	infile rawdat1;
	input citypop number d_sworn d_swo_1 d_swo_2 l_swo_1 l_swo_2   
		d_murd d_rape d_robb d_burg d_assa d_larc d_auto d_crim
		l_murd l_rape l_robb l_assa l_burg l_larc l_auto l_crim
		elec_1 elec_2 gov_1 gov_2 
		c_unemp x_unemp c_a15_24 x_a15_24 c_black c_femhea c_st_edu 
		c_st_wel x_black x_femhea x_st_edu x_st_wel

		yy31 yy32 yy33 yy34 yy35 yy36 yy37 yy38 yy39 yy310
		yy311 yy312 yy313 yy314 yy315 yy316 yy317 yy318 yy319 yy320
		 yy321 yy322 yy323 yy324 yy325
		
		yy41 yy42 yy43 yy44 yy45 yy46 yy47 yy48 yy49 yy410
		yy411 yy412 yy413 yy414 yy415 yy416 yy417 yy418 yy419 yy420
		 yy421 yy422 yy423 yy424 yy425
		
		yy51 yy52 yy53 yy54 yy55 yy56 yy57 yy58 yy59 yy510
		yy511 yy512 yy513 yy514 yy515 yy516 yy517 yy518 yy519 yy520
		 yy521 yy522 yy523 yy524 yy525

		yy61 yy62 yy63 yy64 yy65 yy66 yy67 yy68 yy69 yy610
		yy611 yy612 yy613 yy614 yy615 yy616 yy617 yy618 yy619 yy620
		 yy621 yy622 yy623 yy624 yy625
	
		yy71 yy72 yy73 yy74 yy75 yy76 yy77 yy78 yy79 yy710
		yy711 yy712 yy713 yy714 yy715 yy716 yy717 yy718 yy719 yy720
		 yy721 yy722 yy723 yy724 yy725

		yy81 yy82 yy83 yy84 yy85 yy86 yy87 yy88 yy89 yy810
		yy811 yy812 yy813 yy814 yy815 yy816 yy817 yy818 yy819 yy820
		 yy821 yy822 yy823 yy824 yy825	

		yy91 yy92 yy93 yy94 yy95 yy96 yy97 yy98 yy99 yy910
		yy911 yy912 yy913 yy914 yy915 yy916 yy917 yy918 yy919 yy920
		 yy921 yy922 yy923 yy924 yy925

		cc1 cc2 cc3 cc4 cc5 cc6 cc7 cc8 cc9  cc10
		cc11 cc12 cc13 cc14 cc15 cc16 cc17 cc18 cc19 cc20
		cc21 cc22 cc23 cc24 cc25 cc26 cc27 cc28 cc29 cc30
		cc31 cc32 cc33 cc34 cc35 cc36 cc37 cc38 cc39 cc40
		cc41 cc42 cc43 cc44 cc45 cc46 cc47 cc48 cc49 cc50
		cc51 cc52 cc53 cc54 cc55 cc56 cc57 cc58 cc59
	



		 cs1 cs2 cs3 cs4 cs5 cs6 cs7 cs8 cs9 cs10
		 cs11 cs12 cs13 cs14 cs15 cs16 cs17 cs18 cs19 cs20
		 cs21 cs22 cs23 cs24 cs25 cs26 cs27 cs28

		 icsm1_1  icsm2_1  icsm3_1  icsm4_1  icsm5_1  icsm6_1 
		 icsm7_1  icsm8_1  icsm9_1  icsm10_1 icsm11_1  icsm12_1 
		 icsm13_1  icsm14_1  icsm15_1  icsm16_1  icsm17_1  icsm18_1 
		 icsm19_1  icsm20_1 icsm21_1  icsm22_1  icsm23_1  icsm24_1 
		 icsm25_1  icsm26_1  icsm27_1  icsm28_1 

		 icsm1_2  icsm2_2  icsm3_2  icsm4_2  icsm5_2  icsm6_2 
		 icsm7_2  icsm8_2  icsm9_2  icsm10_2 icsm11_2  icsm12_2 
		 icsm13_2  icsm14_2  icsm15_2  icsm16_2  icsm17_2  icsm18_2 
		 icsm19_2  icsm20_2 icsm21_2  icsm22_2  icsm23_2  icsm24_2 
		 icsm25_2  icsm26_2  icsm27_2  icsm28_2


		 icsg1_1  icsg2_1  icsg3_1  icsg4_1  icsg5_1  icsg6_1 
		 icsg7_1  icsg8_1  icsg9_1  icsg10_1 icsg11_1  icsg12_1 
		 icsg13_1  icsg14_1  icsg15_1  icsg16_1  icsg17_1  icsg18_1 
		 icsg19_1  icsg20_1 icsg21_1  icsg22_1  icsg23_1  icsg24_1 
		 icsg25_1  icsg26_1  icsg27_1  icsg28_1 

		 icsg1_2  icsg2_2  icsg3_2  icsg4_2  icsg5_2  icsg6_2 
		 icsg7_2  icsg8_2  icsg9_2  icsg10_2 icsg11_2  icsg12_2 
		 icsg13_2  icsg14_2  icsg15_2  icsg16_2  icsg17_2  icsg18_2 
		 icsg19_2  icsg20_2 icsg21_2  icsg22_2  icsg23_2  icsg24_2 
		 icsg25_2  icsg26_2  icsg27_2  icsg28_2

 
		rr1 rr2 rr3 rr4 rr5 rr6 rr7 rr8 rr9 rr10
		rr11 rr12 rr13 rr14 rr15 rr16 rr17 rr18 rr19 rr20
		rr21 rr22 rr23 rr24 rr25 rr26 rr27 rr28 rr29 rr30
		rr31 rr32 rr33 rr34 rr35 rr36 rr37 rr38 rr39 rr40
		rr41 rr42 rr43 rr44 rr45 rr46 rr47 rr48 rr49 rr50 
		rr51 rr52 rr53 rr54 rr55 rr56 rr57 rr58 rr59 rr60 
		rr61 rr62 rr63 

		irrm1_1 irrm2_1 irrm3_1 irrm4_1 irrm5_1 irrm6_1
		irrm7_1 irrm8_1 irrm9_1 irrm10_1 irrm11_1 irrm12_1
		irrm13_1 irrm14_1 irrm15_1 irrm16_1 irrm17_1 irrm18_1
		irrm19_1 irrm20_1 irrm21_1 irrm22_1 irrm23_1 irrm24_1
		irrm25_1 irrm26_1 irrm27_1 irrm28_1 irrm29_1 irrm30_1
		irrm31_1 irrm32_1 irrm33_1 irrm34_1 irrm35_1 irrm36_1
		irrm37_1 irrm38_1 irrm39_1 irrm40_1 irrm41_1 irrm42_1
		irrm43_1 irrm44_1 irrm45_1 irrm46_1 irrm47_1 irrm48_1
		irrm49_1 irrm50_1 irrm51_1 irrm52_1 irrm53_1 irrm54_1 
		irrm55_1 irrm56_1 irrm57_1 irrm58_1 irrm59_1 irrm60_1 
		irrm61_1 irrm62_1 irrm63_1 

		irrm1_2 irrm2_2 irrm3_2 irrm4_2 irrm5_2 irrm6_2
		irrm7_2 irrm8_2 irrm9_2 irrm10_2 irrm11_2 irrm12_2
		irrm13_2 irrm14_2 irrm15_2 irrm16_2 irrm17_2 irrm18_2
		irrm19_2 irrm20_2 irrm21_2 irrm22_2 irrm23_2 irrm24_2
		irrm25_2 irrm26_2 irrm27_2 irrm28_2 irrm29_2 irrm30_2
		irrm31_2 irrm32_2 irrm33_2 irrm34_2 irrm35_2 irrm36_2
		irrm37_2 irrm38_2 irrm39_2 irrm40_2 irrm41_2 irrm42_2
		irrm43_2 irrm44_2 irrm45_2 irrm46_2 irrm47_2 irrm48_2
		irrm49_2 irrm50_2 irrm51_2 irrm52_2 irrm53_2 irrm54_2 
		irrm55_2 irrm56_2 irrm57_2 irrm58_2 irrm59_2 irrm60_2 
		irrm61_2 irrm62_2 irrm63_2 

		irrg1_1 irrg2_1 irrg3_1 irrg4_1 irrg5_1 irrg6_1
		irrg7_1 irrg8_1 irrg9_1 irrg10_1 irrg11_1 irrg12_1
		irrg13_1 irrg14_1 irrg15_1 irrg16_1 irrg17_1 irrg18_1
		irrg19_1 irrg20_1 irrg21_1 irrg22_1 irrg23_1 irrg24_1
		irrg25_1 irrg26_1 irrg27_1 irrg28_1 irrg29_1 irrg30_1
		irrg31_1 irrg32_1 irrg33_1 irrg34_1 irrg35_1 irrg36_1
		irrg37_1 irrg38_1 irrg39_1 irrg40_1 irrg41_1 irrg42_1
		irrg43_1 irrg44_1 irrg45_1 irrg46_1 irrg47_1 irrg48_1
		irrg49_1 irrg50_1 irrg51_1 irrg52_1 irrg53_1 irrg54_1 
		irrg55_1 irrg56_1 irrg57_1 irrg58_1 irrg59_1 irrg60_1 
		irrg61_1 irrg62_1 irrg63_1 

		irrg1_2 irrg2_2 irrg3_2 irrg4_2 irrg5_2 irrg6_2
		irrg7_2 irrg8_2 irrg9_2 irrg10_2 irrg11_2 irrg12_2
		irrg13_2 irrg14_2 irrg15_2 irrg16_2 irrg17_2 irrg18_2
		irrg19_2 irrg20_2 irrg21_2 irrg22_2 irrg23_2 irrg24_2
		irrg25_2 irrg26_2 irrg27_2 irrg28_2 irrg29_2 irrg30_2
		irrg31_2 irrg32_2 irrg33_2 irrg34_2 irrg35_2 irrg36_2
		irrg37_2 irrg38_2 irrg39_2 irrg40_2 irrg41_2 irrg42_2
		irrg43_2 irrg44_2 irrg45_2 irrg46_2 irrg47_2 irrg48_2
		irrg49_2 irrg50_2 irrg51_2 irrg52_2 irrg53_2 irrg54_2 
		irrg55_2 irrg56_2 irrg57_2 irrg58_2 irrg59_2 irrg60_2 
		irrg61_2 irrg62_2 irrg63_2 


		im1_el1 im2_el1 im3_el1 im4_el1 im5_el1 im6_el1 im7_el1 
		im1_el2 im2_el2 im3_el2 im4_el2 im5_el2 im6_el2 im7_el2 

		ig1_el1 ig2_el1 ig3_el1 ig4_el1 ig5_el1 ig6_el1 ig7_el1 
		ig1_el2 ig2_el2 ig3_el2 ig4_el2 ig5_el2 ig6_el2 ig7_el2 

		xx1_fem xx2_fem xx3_fem xx4_fem xx5_fem xx6_fem xx7_fem 
		xx1_bla xx2_bla xx3_bla xx4_bla xx5_bla xx6_bla xx7_bla 
		xx1_wel xx2_wel xx3_wel xx4_wel xx5_wel xx6_wel xx7_wel
		xx1_edu xx2_edu xx3_edu xx4_edu xx5_edu xx6_edu xx7_edu
		xx1_une xx2_une xx3_une xx4_une xx5_une xx6_une xx7_une
		xx1_age xx2_age xx3_age xx4_age xx5_age xx6_age xx7_age   

		dd1_fem dd2_fem dd3_fem dd4_fem dd5_fem dd6_fem dd7_fem 
		dd1_bla dd2_bla dd3_bla dd4_bla dd5_bla dd6_bla dd7_bla 
		dd1_wel dd2_wel dd3_wel dd4_wel dd5_wel dd6_wel dd7_wel
		dd1_edu dd2_edu dd3_edu dd4_edu dd5_edu dd6_edu dd7_edu
		dd1_une dd2_une dd3_une dd4_une dd5_une dd6_une dd7_une
		dd1_age dd2_age dd3_age dd4_age dd5_age dd6_age dd7_age   
			
		dswo1_1 dswo2_1 dswo3_1 dswo4_1 dswo5_1 dswo6_1 dswo7_1 
		dswo1_2 dswo2_2 dswo3_2 dswo4_2 dswo5_2 dswo6_2 dswo7_2 

		lswo1_1 lswo2_1 lswo3_1 lswo4_1 lswo5_1 lswo6_1 lswo7_1 
		lswo1_2 lswo2_2 lswo3_2 lswo4_2 lswo5_2 lswo6_2 lswo7_2 

	 if d_crim=. then delete; 

/* this next step aids in restricting demog covariates */

	xxv_fem=xx1_fem + xx2_fem + xx3_fem + xx4_fem;
	xxp_fem=xx5_fem + xx6_fem + xx7_fem;

	xxv_bla=xx1_bla + xx2_bla + xx3_bla + xx4_bla;
	xxp_bla=xx5_bla + xx6_bla + xx7_bla;
 
	xxv_wel=xx1_wel + xx2_wel + xx3_wel + xx4_wel;
	xxp_wel=xx5_wel + xx6_wel + xx7_wel;

	xxv_edu=xx1_edu + xx2_edu + xx3_edu + xx4_edu;
	xxp_edu=xx5_edu + xx6_edu + xx7_edu;

	xxv_une=xx1_une + xx2_une + xx3_une + xx4_une;
	xxp_une=xx5_une + xx6_une + xx7_une;

	xxv_age=xx1_age + xx2_age + xx3_age + xx4_age;
	xxp_age=xx5_age + xx6_age + xx7_age;

	propdum=(number>4);


	ddv_fem=dd1_fem + dd2_fem + dd3_fem + dd4_fem;
	ddp_fem=dd5_fem + dd6_fem + dd7_fem;

	ddv_bla=dd1_bla + dd2_bla + dd3_bla + dd4_bla;
	ddp_bla=dd5_bla + dd6_bla + dd7_bla;
 
	ddv_wel=dd1_wel + dd2_wel + dd3_wel + dd4_wel;
	ddp_wel=dd5_wel + dd6_wel + dd7_wel;

	ddv_edu=dd1_edu + dd2_edu + dd3_edu + dd4_edu;
	ddp_edu=dd5_edu + dd6_edu + dd7_edu;

	ddv_une=dd1_une + dd2_une + dd3_une + dd4_une;
	ddp_une=dd5_une + dd6_une + dd7_une;

	ddv_age=dd1_age + dd2_age + dd3_age + dd4_age;
	ddp_age=dd5_age + dd6_age + dd7_age;


/* these just macros for labeling the instruments */

%macro vreg_in1;	irrm1_1 irrm2_1 irrm3_1 irrm4_1 irrm5_1 irrm6_1
		irrm7_1 irrm8_1 irrm9_1 irrm10_1 irrm11_1 irrm12_1
		irrm13_1 irrm14_1 irrm15_1 irrm16_1 irrm17_1 irrm18_1
		irrm19_1 irrm20_1 irrm21_1 irrm22_1 irrm23_1 irrm24_1
		irrm25_1 irrm26_1 irrm27_1 irrm28_1 irrm29_1 irrm30_1
		irrm31_1 irrm32_1 irrm33_1 irrm34_1 irrm35_1 irrm36_1

		irrg1_1 irrg2_1 irrg3_1 irrg4_1 irrg5_1 irrg6_1
		irrg7_1 irrg8_1 irrg9_1 irrg10_1 irrg11_1 irrg12_1
		irrg13_1 irrg14_1 irrg15_1 irrg16_1 irrg17_1 irrg18_1
		irrg19_1 irrg20_1 irrg21_1 irrg22_1 irrg23_1 irrg24_1
		irrg25_1 irrg26_1 irrg27_1 irrg28_1 irrg29_1 irrg30_1
		irrg31_1 irrg32_1 irrg33_1 irrg34_1 irrg35_1 irrg36_1

%mend;


%macro preg_in1;	irrm37_1 irrm38_1 irrm39_1 irrm40_1 irrm41_1 irrm42_1
		irrm43_1 irrm44_1 irrm45_1 irrm46_1 irrm47_1 irrm48_1
		irrm49_1 irrm50_1 irrm51_1 irrm52_1 irrm53_1 irrm54_1 
		irrm55_1 irrm56_1 irrm57_1 irrm58_1 irrm59_1 irrm60_1 
		irrm61_1 irrm62_1 irrm63_1 
	
		irrg37_1 irrg38_1 irrg39_1 irrg40_1 irrg41_1 irrg42_1
		irrg43_1 irrg44_1 irrg45_1 irrg46_1 irrg47_1 irrg48_1
		irrg49_1 irrg50_1 irrg51_1 irrg52_1 irrg53_1 irrg54_1 
		irrg55_1 irrg56_1 irrg57_1 irrg58_1 irrg59_1 irrg60_1 
		irrg61_1 irrg62_1 irrg63_1 


%mend;


%macro vreg_in2;	irrm1_2 irrm2_2 irrm3_2 irrm4_2 irrm5_2 irrm6_2
		irrm7_2 irrm8_2 irrm9_2 irrm10_2 irrm11_2 irrm12_2
		irrm13_2 irrm14_2 irrm15_2 irrm16_2 irrm17_2 irrm18_2
		irrm19_2 irrm20_2 irrm21_2 irrm22_2 irrm23_2 irrm24_2
		irrm25_2 irrm26_2 irrm27_2 irrm28_2 irrm29_2 irrm30_2
		irrm31_2 irrm32_2 irrm33_2 irrm34_2 irrm35_2 irrm36_2

		irrg1_2 irrg2_2 irrg3_2 irrg4_2 irrg5_2 irrg6_2
		irrg7_2 irrg8_2 irrg9_2 irrg10_2 irrg11_2 irrg12_2
		irrg13_2 irrg14_2 irrg15_2 irrg16_2 irrg17_2 irrg18_2
		irrg19_2 irrg20_2 irrg21_2 irrg22_2 irrg23_2 irrg24_2
		irrg25_2 irrg26_2 irrg27_2 irrg28_2 irrg29_2 irrg30_2
		irrg31_2 irrg32_2 irrg33_2 irrg34_2 irrg35_2 irrg36_2
%mend;


%macro preg_in2;	irrm37_2 irrm38_2 irrm39_2 irrm40_2 irrm41_2 irrm42_2
		irrm43_2 irrm44_2 irrm45_2 irrm46_2 irrm47_2 irrm48_2
		irrm49_2 irrm50_2 irrm51_2 irrm52_2 irrm53_2 irrm54_2 
		irrm55_2 irrm56_2 irrm57_2 irrm58_2 irrm59_2 irrm60_2 
		irrm61_2 irrm62_2 irrm63_2 

		irrg37_2 irrg38_2 irrg39_2 irrg40_2 irrg41_2 irrg42_2
		irrg43_2 irrg44_2 irrg45_2 irrg46_2 irrg47_2 irrg48_2
		irrg49_2 irrg50_2 irrg51_2 irrg52_2 irrg53_2 irrg54_2 
		irrg55_2 irrg56_2 irrg57_2 irrg58_2 irrg59_2 irrg60_2 
		irrg61_2 irrg62_2 irrg63_2 
%mend;




%macro vcs_in1;	 icsm1_1  icsm2_1  icsm3_1  icsm4_1  icsm5_1  icsm6_1 
		 icsm7_1  icsm8_1  icsm9_1  icsm10_1 icsm11_1  icsm12_1 
		 icsm13_1  icsm14_1  icsm15_1  icsm16_1
		 icsg1_1  icsg2_1  icsg3_1  icsg4_1  icsg5_1  icsg6_1 
		 icsg7_1  icsg8_1  icsg9_1  icsg10_1 icsg11_1  icsg12_1 
		 icsg13_1  icsg14_1  icsg15_1  icsg16_1	
%mend;

%macro pcs_in1;	 icsg17_1  icsg18_1 
		 icsg19_1  icsg20_1 icsg21_1  icsg22_1  icsg23_1  icsg24_1 
		 icsg25_1  icsg26_1  icsg27_1  icsg28_1 
   		 icsm17_1  icsm18_1 
		 icsm19_1  icsm20_1 icsm21_1  icsm22_1  icsm23_1  icsm24_1 
		 icsm25_1  icsm26_1  icsm27_1  icsm28_1 
%mend;


%macro vcs_in2;	 icsm1_2  icsm2_2  icsm3_2  icsm4_2  icsm5_2  icsm6_2 
		 icsm7_2  icsm8_2  icsm9_2  icsm10_2 icsm11_2  icsm12_2 
		 icsm13_2  icsm14_2  icsm15_2  icsm16_2
		 icsg1_2  icsg2_2  icsg3_2  icsg4_2  icsg5_2  icsg6_2 
		 icsg7_2  icsg8_2  icsg9_2  icsg10_2 icsg11_2  icsg12_2 
		 icsg13_2  icsg14_2  icsg15_2  icsg16_2	
%mend;

%macro pcs_in2;	 icsg17_2  icsg18_2 
		 icsg19_2  icsg20_2 icsg21_2  icsg22_2  icsg23_2  icsg24_2 
		 icsg25_2  icsg26_2  icsg27_2  icsg28_2 
   		 icsm17_2  icsm18_2 
		 icsm19_2  icsm20_2 icsm21_2  icsm22_2  icsm23_2  icsm24_2 
		 icsm25_2  icsm26_2  icsm27_2  icsm28_2 
%mend;

%macro vele_in1;	im1_el1 im2_el1 im3_el1 im4_el1
		ig1_el1 ig2_el1 ig3_el1 ig4_el1
%mend;		

%macro pele_in1;	 im5_el1 im6_el1 im7_el1 
		 ig5_el1 ig6_el1 ig7_el1 
%mend;

%macro vele_in2;	im1_el2 im2_el2 im3_el2 im4_el2
		ig1_el2 ig2_el2 ig3_el2 ig4_el2
%mend;		

%macro pele_in2;	 im5_el2 im6_el2 im7_el2 
		 ig5_el2 ig6_el2 ig7_el2 
%mend;

/* these just macros for labeling the covariates */

%macro citdum;		cc1 cc2 cc3 cc4 cc5 cc6 cc7 cc8 cc9 
		cc11 cc12 cc13 cc14 cc15 cc16 cc17 cc18 cc19 cc20
		cc21 cc22 cc23 cc24 cc25 cc26 cc27 cc28 cc29 cc30
		cc31 cc32 cc33 cc34 cc35 cc36 cc37 cc38 cc39 cc40
		cc41 cc42 cc43 cc44 cc45 cc46 cc47 cc48 cc49 cc50
		cc51 cc52 cc53 cc54 cc55 cc56 cc57 cc58 cc59
%mend;


%macro vregion;	rr1 rr2 rr3 rr4 rr5 rr6 rr7 rr8 rr9 rr10
		rr11 rr12 rr13 rr14 rr15 rr16 rr17 rr18 rr19 rr20
		rr21 rr22 rr23 rr24 rr25 rr26 rr27 rr28 rr29 rr30
		rr31 rr32 rr33 rr34 rr35 rr36
%mend;

%macro pregion;	rr37 rr38 rr39 rr40
		rr41 rr42 rr43 rr44 rr45 rr46 rr47 rr48 rr49 rr50 
		rr51 rr52 rr53 rr54 rr55 rr56 rr57 rr58 rr59 rr60 
		rr61 rr62 rr63 
%mend;

%macro vcitsiz;	 cs1 cs2 cs3 cs4 cs5 cs6 cs7 cs8 cs9 cs10
		 cs11 cs12 cs13 cs14 cs15 cs16 
%mend;

%macro pcitsiz;	 cs17 cs18 cs19 cs20
		 cs21 cs22 cs23 cs24 cs25 cs26 cs27 cs28
%mend;


%macro vyears;	yy31 yy32 yy33 yy34 yy35 yy36 yy37 yy38 yy39 yy310
		yy311 yy312 yy313 yy314 yy315 yy316 yy317 yy318 yy319 yy320
		 yy321 yy322 yy323 yy324 yy325
		
		yy41 yy42 yy43 yy44 yy45 yy46 yy47 yy48 yy49 yy410
		yy411 yy412 yy413 yy414 yy415 yy416 yy417 yy418 yy419 yy420
		 yy421 yy422 yy423 yy424 yy425
		
		yy51 yy52 yy53 yy54 yy55 yy56 yy57 yy58 yy59 yy510
		yy511 yy512 yy513 yy514 yy515 yy516 yy517 yy518 yy519 yy520
		 yy521 yy522 yy523 yy524 yy525

		yy61 yy62 yy63 yy64 yy65 yy66 yy67 yy68 yy69 yy610
		yy611 yy612 yy613 yy614 yy615 yy616 yy617 yy618 yy619 yy620
		 yy621 yy622 yy623 yy624 yy625
%mend;

%macro pyears;	yy71 yy72 yy73 yy74 yy75 yy76 yy77 yy78 yy79 yy710
		yy711 yy712 yy713 yy714 yy715 yy716 yy717 yy718 yy719 yy720
		 yy721 yy722 yy723 yy724 yy725

		yy81 yy82 yy83 yy84 yy85 yy86 yy87 yy88 yy89 yy810
		yy811 yy812 yy813 yy814 yy815 yy816 yy817 yy818 yy819 yy820
		 yy821 yy822 yy823 yy824 yy825	

		yy91 yy92 yy93 yy94 yy95 yy96 yy97 yy98 yy99 yy910
		yy911 yy912 yy913 yy914 yy915 yy916 yy917 yy918 yy919 yy920
		 yy921 yy922 yy923 yy924 yy925
%mend;

%macro vdifcov;	dd1_fem dd2_fem dd3_fem dd4_fem
		dd1_bla dd2_bla dd3_bla dd4_bla
		dd1_wel dd2_wel dd3_wel dd4_wel
		dd1_edu dd2_edu dd3_edu dd4_edu
		dd1_une dd2_une dd3_une dd4_une
		dd1_age dd2_age dd3_age dd4_age
%mend;

%macro pdifcov; dd5_fem dd6_fem dd7_fem 
 		dd5_bla dd6_bla dd7_bla 
 		dd5_wel dd6_wel dd7_wel
 		dd5_edu dd6_edu dd7_edu
 		dd5_une dd6_une dd7_une
 		dd5_age dd6_age dd7_age
%mend;

%macro vlevcov;	xx1_fem xx2_fem xx3_fem xx4_fem
		xx1_bla xx2_bla xx3_bla xx4_bla
		xx1_wel xx2_wel xx3_wel xx4_wel
		xx1_edu xx2_edu xx3_edu xx4_edu
		xx1_une xx2_une xx3_une xx4_une
		xx1_age xx2_age xx3_age xx4_age
%mend;



	


%macro plevcov; xx5_fem xx6_fem xx7_fem 
 		xx5_bla xx6_bla xx7_bla 
 		xx5_wel xx6_wel xx7_wel
 		xx5_edu xx6_edu xx7_edu
 		xx5_une xx6_une xx7_une
 		xx5_age xx6_age xx7_age
%mend;


%macro vdifres; 	ddv_fem ddv_bla ddv_edu ddv_wel ddv_une ddv_age
%mend;

%macro pdifres; 	ddp_fem ddp_bla ddp_edu ddp_wel ddp_une ddp_age
%mend;

%macro vlevres; 	xxv_fem xxv_bla xxv_edu xxv_wel xxv_une xxv_age
%mend;

%macro plevres; 	xxp_fem xxp_bla xxp_edu xxp_wel xxp_une xxp_age
%mend;

%macro vdswo_1;	dswo1_1 dswo2_1 dswo3_1 dswo4_1
%mend;

%macro vdswo_2;	dswo1_2 dswo2_2 dswo3_2 dswo4_2
%mend;

%macro pdswo_1; dswo5_1 dswo6_1 dswo7_1 
%mend;

%macro pdswo_2; dswo5_2 dswo6_2 dswo7_2 
%mend;



%macro vlswo_1;	lswo1_1 lswo2_1 lswo3_1 lswo4_1
%mend;

%macro vlswo_2;	lswo1_2 lswo2_2 lswo3_2 lswo4_2
%mend;

%macro plswo_1; lswo5_1 lswo6_1 lswo7_1 
%mend;

%macro plswo_2; lswo5_2 lswo6_2 lswo7_2 
%mend;



run;


/* first do all crimes together, no constraints on coefficients */

/* ols in logs */

proc syslin  data=pol_tem2  out=pol_tem2 noprint; 
	title 'all crims OLS in levels  -- no parameter restrictions';
	model l_crim= %vlswo_1 %vlswo_2 %plswo_1 %plswo_2 %vlevcov
			%plevcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
	test lswo1_1+lswo1_2=0;
	test lswo2_1+lswo2_2=0;
	test lswo3_1+lswo3_2=0;
	test lswo4_1+lswo4_2=0;
	test lswo5_1+lswo5_2=0;
	test lswo6_1+lswo6_2=0;
	test lswo7_1+lswo7_2=0;
	output R=yresid;

/* this following stuff is just doing FGLS allowing for differing variances by crime category */

proc means data=pol_tem2;
	var yresid;
	by number;
	output  out=stdpol std=holdstd;

proc sort data=pol_tem2;
	by number;

proc sort data=stdpol;
	by number;

data pol_tem2;
	merge pol_tem2 stdpol;
	by number;
	 
	holdwght=1/(holdstd*holdstd);

proc means data=pol_tem2;
	var holdwght;
	by number;


proc syslin data=pol_tem2 ; 
	title 'weighted all crimes OLS in levels  -- no parameter restrictions';
	model l_crim= %vlswo_1 %vlswo_2 %plswo_1 %plswo_2 %vlevcov
			%plevcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
	test lswo1_1+lswo1_2=0;
	test lswo2_1+lswo2_2=0;
	test lswo3_1+lswo3_2=0;
	test lswo4_1+lswo4_2=0;
	test lswo5_1+lswo5_2=0;
	test lswo6_1+lswo6_2=0;
	test lswo7_1+lswo7_2=0;
	test
		lswo1_1+lswo1_2 = lswo2_1+lswo2_2,
		lswo1_1+lswo1_2 = lswo3_1+lswo3_2,
		lswo1_1+lswo1_2 = lswo4_1+lswo4_2;
	test
		lswo5_1+lswo5_2 = lswo6_1+lswo6_2,
		lswo5_1+lswo5_2 = lswo7_1+lswo7_2;
	weight holdwght;

data pol_tem2;
	set pol_tem2;
	drop holdwght holdstd yresid;



 /* now do ols in levels restricting property crims to be same, viol to be same */


proc syslin data=pol_tem2 out=pol_tem2 noprint; 
	title 'all crims OLS in levels  -- prop viol restricted';
	model l_crim= %vlswo_1 %vlswo_2 %plswo_1 %plswo_2 %vlevres
			%plevres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
	restrict
		lswo1_1+lswo1_2 = lswo2_1+lswo2_2,
		lswo1_1+lswo1_2 = lswo3_1+lswo3_2,
		lswo1_1+lswo1_2 = lswo4_1+lswo4_2,

		lswo5_1+lswo5_2 = lswo6_1+lswo6_2,
		lswo5_1+lswo5_2 = lswo7_1+lswo7_2;
	test lswo1_1+lswo1_2=0;
	test lswo5_1+lswo5_2=0;

	output R=yresid;

proc means data=pol_tem2;
	var yresid;
	by number;
	output  out=stdpol std=holdstd;

proc sort data=pol_tem2;
	by number;

proc sort data=stdpol;
	by number;

data pol_tem2;
	merge pol_tem2 stdpol;
	by number;
	 
	holdwght=1/(holdstd*holdstd);

proc syslin data=pol_tem2 ; 
	title 'all crims OLS in levels  -- prop viol restricted';
	model l_crim= %vlswo_1 %vlswo_2 %plswo_1 %plswo_2 %vlevres
			%plevres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
	restrict
		lswo1_1+lswo1_2 = lswo2_1+lswo2_2,
		lswo1_1+lswo1_2 = lswo3_1+lswo3_2,
		lswo1_1+lswo1_2 = lswo4_1+lswo4_2,

		lswo5_1+lswo5_2 = lswo6_1+lswo6_2,
		lswo5_1+lswo5_2 = lswo7_1+lswo7_2;
	weight holdstd;
	test lswo1_1+lswo1_2=0;
	test lswo5_1+lswo5_2=0;


data pol_tem2;
	set pol_tem2;
	drop holdwght holdstd yresid;


 /* Now do unrestricted with ols in log differences */



proc syslin data=pol_tem2 out=pol_tem2 noprint; 
	title 'all crims OLS in log diffs  -- no parameter restrictions';
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifcov
			%pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
	test dswo1_1+dswo1_2=0;
	test dswo2_1+dswo2_2=0;
	test dswo3_1+dswo3_2=0;
	test dswo4_1+dswo4_2=0;
	test dswo5_1+dswo5_2=0;
	test dswo6_1+dswo6_2=0;
	test dswo7_1+dswo7_2=0;
	output R=yresid;

proc means data=pol_tem2;
	var yresid;
	by number;
	output  out=stdpol std=holdstd;

proc sort data=pol_tem2;
	by number;

proc sort data=stdpol;
	by number;

data pol_tem2;
	merge pol_tem2 stdpol;
	by number;
	 
	holdwght=1/(holdstd*holdstd);


proc syslin data=pol_tem2 ; 
	title 'weighted all crims OLS in log diffs  -- no parameter restrictions';
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifcov
			%pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
	test dswo1_1+dswo1_2=0;
	test dswo2_1+dswo2_2=0;
	test dswo3_1+dswo3_2=0;
	test dswo4_1+dswo4_2=0;
	test dswo5_1+dswo5_2=0;
	test dswo6_1+dswo6_2=0;
	test dswo7_1+dswo7_2=0;
	test
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2;
	test
		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	weight holdwght;

data pol_tem2;
	set pol_tem2;
	drop holdwght holdstd yresid;




 /* now do ols in log diffs restricting property crims to be same, viol to be same  */
 


proc syslin data=pol_tem2 out=pol_tem2 noprint; 
	title 'all crims OLS in log diffs  -- viol, prop restrictions';
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifres
			%pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
	restrict
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2,

		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	test dswo1_1+dswo1_2=0;
	test dswo5_1+dswo5_2=0;
	output R=yresid;

proc means data=pol_tem2;
	var yresid;
	by number;
	output  out=stdpol std=holdstd;

proc sort data=pol_tem2;
	by number;

proc sort data=stdpol;
	by number;

data pol_tem2;
	merge pol_tem2 stdpol;
	by number;
	 
	holdwght=1/(holdstd*holdstd);


proc syslin data=pol_tem2 ; 
	title 'weighted all crims OLS in log diffs  -- viol, prop restrictions';
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifres
			%pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
	restrict
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2,

		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	test dswo1_1+dswo1_2=0;
	test dswo5_1+dswo5_2=0;
	weight holdstd;
	

data pol_tem2;
	set pol_tem2;
	drop holdwght holdstd yresid;




/* unrestricted 2sls with elections as instruments */


proc syslin data=pol_tem2 out=pol_tem2 2sls ; 
	title 'all crimes  2sls using elections  -- unrestricted';
	instruments  %vele_in1 %vele_in2 %pele_in1 %pele_in2
			 %vdifcov %pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifcov
			%pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;

	test dswo1_1+dswo1_2=0;
	test dswo2_1+dswo2_2=0;
	test dswo3_1+dswo3_2=0;
	test dswo4_1+dswo4_2=0;
	test dswo5_1+dswo5_2=0;
	test dswo6_1+dswo6_2=0;
	test dswo7_1+dswo7_2=0;
	output R=yresid;

proc means data=pol_tem2;
	var yresid;
	by number;
	output  out=stdpol std=holdstd;

proc sort data=pol_tem2;
	by number;

proc sort data=stdpol;
	by number;

data pol_tem2;
	merge pol_tem2 stdpol;
	by number;
	 
	holdwght=1/(holdstd*holdstd);


proc syslin data=pol_tem2 out=pol_tem2 2sls; 
	title 'weighted all crimes  2sls using elections  -- no  restrictions';
	instruments  %vele_in1 %vele_in2 %pele_in1 %pele_in2
			 %vdifcov %pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifcov
			%pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	test dswo1_1+dswo1_2=0;
	test dswo2_1+dswo2_2=0;
	test dswo3_1+dswo3_2=0;
	test dswo4_1+dswo4_2=0;
	test dswo5_1+dswo5_2=0;
	test dswo6_1+dswo6_2=0;
	test dswo7_1+dswo7_2=0;
	test
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2;
	test
		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	weight holdstd;
	output R=resid2;


proc reg data=pol_tem2;
	title 'tests of overid for unrestricted 2sls election instruments';
	model resid2=  %vele_in1 %vele_in2 %pele_in1 %pele_in2
			 %vdifcov %pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
	weight holdstd;


data pol_tem2;
	set pol_tem2;
	drop holdwght holdstd yresid resid2;








 /* now do 2sls in log diffs restricting property crims to be same, viol to be same  using elections only as instruments */
 


proc syslin data=pol_tem2 out=pol_tem2 2sls ; 
	title 'all crimes  2sls using elections  -- viol, prop restrictions';
	instruments  %vele_in1 %vele_in2 %pele_in1 %pele_in2
			 %vdifres %pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifres
			%pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	restrict
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2,

		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	test dswo1_1+dswo1_2=0;
	test dswo5_1+dswo5_2=0;
	output R=yresid;

proc means data=pol_tem2;
	var yresid;
	by number;
	output  out=stdpol std=holdstd;

proc sort data=pol_tem2;
	by number;

proc sort data=stdpol;
	by number;

data pol_tem2;
	merge pol_tem2 stdpol;
	by number;
	 
	holdwght=1/(holdstd*holdstd);


proc syslin data=pol_tem2 out=pol_tem2 2sls; 
	title 'weighted all crimes  2sls using elections  -- viol, prop restrictions';
	instruments  %vele_in1 %vele_in2 %pele_in1 %pele_in2
			 %vdifres %pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifres
			%pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	restrict
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2,

		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	test dswo1_1+dswo1_2=0;
	test dswo5_1+dswo5_2=0;
	weight holdstd;
	output R=resid2;

proc reg data=pol_tem2;
	title 'tests of overid for restricted 2sls election instruments';
	model resid2=  %vele_in1 %vele_in2 %pele_in1 %pele_in2
			 %vdifres %pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
	weight holdstd;


data pol_tem2;
	set pol_tem2;
	drop holdwght holdstd yresid resid2;


/* now 2sls using citysize/election interactions as instruments */

/*  first unrestricted */


proc syslin data=pol_tem2 out=pol_tem2 2sls noprint ; 
	title 'all crimes  2sls using city size  -- viol, prop unrestricted';
	instruments  %vcs_in1 %vcs_in2 %pcs_in1 %pcs_in2
			 %vdifcov %pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifcov
			%pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	test dswo1_1+dswo1_2=0;
	test dswo2_1+dswo2_2=0;
	test dswo3_1+dswo3_2=0;
	test dswo4_1+dswo4_2=0;
	test dswo5_1+dswo5_2=0;
	test dswo6_1+dswo6_2=0;
	test dswo7_1+dswo7_2=0;
	output R=yresid;

proc means data=pol_tem2;
	var yresid;
	by number;
	output  out=stdpol std=holdstd;

proc sort data=pol_tem2;
	by number;

proc sort data=stdpol;
	by number;

data pol_tem2;
	merge pol_tem2 stdpol;
	by number;
	 
	holdwght=1/(holdstd*holdstd);


proc syslin data=pol_tem2 out=pol_tem2 2sls; 
	title 'weighted all crimes  2sls using city size  -- unrestricted';
	instruments  %vcs_in1 %vcs_in2 %pcs_in1 %pcs_in2
			 %vdifcov %pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifcov
			%pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;

	test dswo1_1+dswo1_2=0;
	test dswo2_1+dswo2_2=0;
	test dswo3_1+dswo3_2=0;
	test dswo4_1+dswo4_2=0;
	test dswo5_1+dswo5_2=0;
	test dswo6_1+dswo6_2=0;
	test dswo7_1+dswo7_2=0;
	test
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2;
	test
		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	weight holdstd;
	output R=resid2;


proc reg data=pol_tem2;
	title 'Overid test for unrestricted with citysize as instruments';
	model resid2=  %vcs_in1 %vcs_in2 %pcs_in1 %pcs_in2
			 %vdifcov %pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
	weight holdstd;


data pol_tem2;
	set pol_tem2;
	drop holdwght holdstd yresid resid2;

/* NOw restricted */


proc syslin data=pol_tem2 out=pol_tem2 2sls noprint ; 
	title 'all crimes  2sls using citysize  -- viol, prop restrictions';
	instruments  %vcs_in1 %vcs_in2 %pcs_in1 %pcs_in2
			 %vdifres %pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifres
			%pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	restrict
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2,

		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	test dswo1_1+dswo1_2=0;
	test dswo5_1+dswo5_2=0;
	output R=yresid;



proc means data=pol_tem2;
	var yresid;
	by number;
	output  out=stdpol std=holdstd;

proc sort data=pol_tem2;
	by number;

proc sort data=stdpol;
	by number;

data pol_tem2;
	merge pol_tem2 stdpol;
	by number;
	 
	holdwght=1/(holdstd*holdstd);


proc syslin data=pol_tem2 out=pol_tem2 2sls; 
	title 'weighted all crimes  2sls using city size  -- viol, prop restrictions';
	instruments  %vcs_in1 %vcs_in2 %pcs_in1 %pcs_in2
			 %vdifres %pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifres
			%pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	restrict
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2,

		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	test dswo1_1+dswo1_2=0;
	test dswo5_1+dswo5_2=0;
	weight holdstd;
	output R=resid2;


proc reg data=pol_tem2;
	title 'Overid test for restricted with citysize as instruments';
	model resid2=  %vcs_in1 %vcs_in2 %pcs_in1 %pcs_in2
			 %vdifres %pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;	
	weight holdstd;


data pol_tem2;
	set pol_tem2;
	drop holdwght holdstd yresid resid2;



/* now 2sls using region/election interactions */

/* first unrestricted */

proc syslin data=pol_tem2 out=pol_tem2 2sls noprint; 
	title 'all crimes  2sls using regions  -- unrestricted';
	instruments  %vreg_in1 %vreg_in2 %preg_in1 %preg_in2
			 %vdifcov %pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifcov
			%pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	test dswo1_1+dswo1_2=0;
	test dswo2_1+dswo2_2=0;
	test dswo3_1+dswo3_2=0;
	test dswo4_1+dswo4_2=0;
	test dswo5_1+dswo5_2=0;
	test dswo6_1+dswo6_2=0;
	test dswo7_1+dswo7_2=0;
	output R=yresid;

proc means data=pol_tem2;
	var yresid;
	by number;
	output  out=stdpol std=holdstd;

proc sort data=pol_tem2;
	by number;

proc sort data=stdpol;
	by number;

data pol_tem2;
	merge pol_tem2 stdpol;
	by number;
	 
	holdwght=1/(holdstd*holdstd);


proc syslin data=pol_tem2 out=pol_tem2 2sls; 
	title 'weighted all crimes  2sls using regions  -- unrestricted';
	instruments  %vreg_in1 %vreg_in2 %preg_in1 %preg_in2
			 %vdifcov %pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifcov
			%pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	test dswo1_1+dswo1_2=0;
	test dswo2_1+dswo2_2=0;
	test dswo3_1+dswo3_2=0;
	test dswo4_1+dswo4_2=0;
	test dswo5_1+dswo5_2=0;
	test dswo6_1+dswo6_2=0;
	test dswo7_1+dswo7_2=0;
	test
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2;
	test
		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	weight holdstd;
	output R=resid2;


proc reg data=pol_tem2;
	title 'Overid test for unrestricted with regions as instruments';
	model resid2= %vreg_in1 %vreg_in2 %preg_in1 %preg_in2
			 %vdifcov %pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
	weight holdstd;


data pol_tem2;
	set pol_tem2;
	drop holdwght holdstd yresid resid2;



/* Now restricted */

proc syslin data=pol_tem2 out=pol_tem2 2sls ; 
	title 'all crimes  2sls using regions  -- viol, prop restrictions';
	instruments  %vreg_in1 %vreg_in2 %preg_in1 %preg_in2
			 %vdifres %pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifres
			%pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	restrict
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2,

		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	test dswo1_1+dswo1_2=0;
	test dswo5_1+dswo5_2=0;
	output R=yresid;

proc means data=pol_tem2;
	var yresid;
	by number;
	output  out=stdpol std=holdstd;

proc sort data=pol_tem2;
	by number;

proc sort data=stdpol;
	by number;

data pol_tem2;
	merge pol_tem2 stdpol;
	by number;
	 
	holdwght=1/(holdstd*holdstd);


proc syslin data=pol_tem2 out=pol_tem2 2sls; 
	title 'weighted all crimes  2sls using regions  -- viol, prop restrictions';
	instruments  %vreg_in1 %vreg_in2 %preg_in1 %preg_in2
			 %vdifres %pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifres
			%pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	restrict
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2,

		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	test dswo1_1+dswo1_2=0;
	test dswo5_1+dswo5_2=0;
	weight holdstd;
	output R=resid2;

proc reg data=pol_tem2;
	title 'Overid test for restricted with regions as instruments';
	model resid2= %vreg_in1 %vreg_in2 %preg_in1 %preg_in2
			 %vdifres %pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
	weight holdstd;

data pol_tem2;
	set pol_tem2;
	drop holdwght holdstd yresid resid2;




/*  NOW LIML */




 /* now do liml in log diffs restricting property crims to be same, viol to be same  using elections only as instruments */
 


proc syslin data=pol_tem2 out=pol_tem2 liml ; 
	title 'all crimes  liml using elections  -- restricted';
	instruments  %vele_in1 %vele_in2 %pele_in1 %pele_in2
			 %vdifres %pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifres
			%pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	restrict
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2,

		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	test dswo1_1+dswo1_2=0;
	test dswo5_1+dswo5_2=0;
	output R=yresid;

proc means data=pol_tem2;
	var yresid;
	by number;
	output  out=stdpol std=holdstd;

proc sort data=pol_tem2;
	by number;

proc sort data=stdpol;
	by number;

data pol_tem2;
	merge pol_tem2 stdpol;
	by number;
	 
	holdwght=1/(holdstd*holdstd);


proc syslin data=pol_tem2 liml; 
	title 'weighted all crimes  liml using elections  -- restricted';
	instruments  %vele_in1 %vele_in2 %pele_in1 %pele_in2
			 %vdifres %pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifres
			%pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	restrict
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2,

		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	test dswo1_1+dswo1_2=0;
	test dswo5_1+dswo5_2=0;
	weight holdstd;
	

data pol_tem2;
	set pol_tem2;
	drop holdwght holdstd yresid;














/* now liml using citysize/election interactions as instruments */

/*  first unrestricted */


proc syslin data=pol_tem2 out=pol_tem2 liml noprint ; 
	title 'all crimes  liml using citysize  -- unrestricted';
	instruments  %vcs_in1 %vcs_in2 %pcs_in1 %pcs_in2
			 %vdifcov %pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifcov
			%pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	test dswo1_1+dswo1_2=0;
	test dswo2_1+dswo2_2=0;
	test dswo3_1+dswo3_2=0;
	test dswo4_1+dswo4_2=0;
	test dswo5_1+dswo5_2=0;
	test dswo6_1+dswo6_2=0;
	test dswo7_1+dswo7_2=0;
	output R=yresid;

proc means data=pol_tem2;
	var yresid;
	by number;
	output  out=stdpol std=holdstd;

proc sort data=pol_tem2;
	by number;

proc sort data=stdpol;
	by number;

data pol_tem2;
	merge pol_tem2 stdpol;
	by number;
	 
	holdwght=1/(holdstd*holdstd);


proc syslin data=pol_tem2 liml; 
	title 'weighted all crimes  liml using citysize  -- unrestricted';
	instruments  %vcs_in1 %vcs_in2 %pcs_in1 %pcs_in2
			 %vdifcov %pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifcov
			%pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;

	test dswo1_1+dswo1_2=0;
	test dswo2_1+dswo2_2=0;
	test dswo3_1+dswo3_2=0;
	test dswo4_1+dswo4_2=0;
	test dswo5_1+dswo5_2=0;
	test dswo6_1+dswo6_2=0;
	test dswo7_1+dswo7_2=0;
	test
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2;
	test
		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	weight holdstd;
	

data pol_tem2;
	set pol_tem2;
	drop holdwght holdstd yresid;

/* NOw restricted */


proc syslin data=pol_tem2 out=pol_tem2 liml noprint ; 
	title 'all crimes  liml using citysize  -- viol, prop restrictions';
	instruments  %vcs_in1 %vcs_in2 %pcs_in1 %pcs_in2
			 %vdifres %pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifres
			%pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	restrict
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2,

		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	test dswo1_1+dswo1_2=0;
	test dswo5_1+dswo5_2=0;
	output R=yresid;

proc means data=pol_tem2;
	var yresid;
	by number;
	output  out=stdpol std=holdstd;

proc sort data=pol_tem2;
	by number;

proc sort data=stdpol;
	by number;

data pol_tem2;
	merge pol_tem2 stdpol;
	by number;
	 
	holdwght=1/(holdstd*holdstd);


proc syslin data=pol_tem2 liml; 
	title 'weighted all crimes  liml using citysize  -- viol, prop restrictions';
	instruments  %vcs_in1 %vcs_in2 %pcs_in1 %pcs_in2
			 %vdifres %pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifres
			%pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	restrict
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2,

		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	test dswo1_1+dswo1_2=0;
	test dswo5_1+dswo5_2=0;
	weight holdstd;
	

data pol_tem2;
	set pol_tem2;
	drop holdwght holdstd yresid;



/* now liml using region/election interactions */

/* first unrestricted */

proc syslin data=pol_tem2 out=pol_tem2 liml noprint; 
	title 'all crimes  liml using regions  -- unrestricted';
	instruments  %vreg_in1 %vreg_in2 %preg_in1 %preg_in2
			 %vdifcov %pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifcov
			%pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	test dswo1_1+dswo1_2=0;
	test dswo2_1+dswo2_2=0;
	test dswo3_1+dswo3_2=0;
	test dswo4_1+dswo4_2=0;
	test dswo5_1+dswo5_2=0;
	test dswo6_1+dswo6_2=0;
	test dswo7_1+dswo7_2=0;
	output R=yresid;

proc means data=pol_tem2;
	var yresid;
	by number;
	output  out=stdpol std=holdstd;

proc sort data=pol_tem2;
	by number;

proc sort data=stdpol;
	by number;

data pol_tem2;
	merge pol_tem2 stdpol;
	by number;
	 
	holdwght=1/(holdstd*holdstd);


proc syslin data=pol_tem2 liml; 
	title 'weighted all crimes  liml using regions  -- unrestricted';
	instruments  %vreg_in1 %vreg_in2 %preg_in1 %preg_in2
			 %vdifcov %pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifcov
			%pdifcov %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	test dswo1_1+dswo1_2=0;
	test dswo2_1+dswo2_2=0;
	test dswo3_1+dswo3_2=0;
	test dswo4_1+dswo4_2=0;
	test dswo5_1+dswo5_2=0;
	test dswo6_1+dswo6_2=0;
	test dswo7_1+dswo7_2=0;
	test
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2;
	test
		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	weight holdstd;
	

data pol_tem2;
	set pol_tem2;
	drop holdwght holdstd yresid;



/* Now restricted */

proc syslin data=pol_tem2 out=pol_tem2 liml ; 
	title 'all crimes  liml using regions  -- viol, prop restrictions';
	instruments  %vreg_in1 %vreg_in2 %preg_in1 %preg_in2
			 %vdifres %pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifres
			%pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	restrict
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2,

		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	test dswo1_1+dswo1_2=0;
	test dswo5_1+dswo5_2=0;
	output R=yresid;

proc means data=pol_tem2;
	var yresid;
	by number;
	output  out=stdpol std=holdstd;

proc sort data=pol_tem2;
	by number;

proc sort data=stdpol;
	by number;

data pol_tem2;
	merge pol_tem2 stdpol;
	by number;
	 
	holdwght=1/(holdstd*holdstd);


proc syslin data=pol_tem2 liml; 
	title 'weighted all crimes  liml using regions  -- viol, prop restrictions';
	instruments  %vreg_in1 %vreg_in2 %preg_in1 %preg_in2
			 %vdifres %pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears ;
 	endogenous  d_crim %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2;
	model d_crim= %vdswo_1 %vdswo_2 %pdswo_1 %pdswo_2 %vdifres
			%pdifres %citdum  
			%vcitsiz %pcitsiz %vyears %pyears / overid ;
	restrict
		dswo1_1+dswo1_2 = dswo2_1+dswo2_2,
		dswo1_1+dswo1_2 = dswo3_1+dswo3_2,
		dswo1_1+dswo1_2 = dswo4_1+dswo4_2,

		dswo5_1+dswo5_2 = dswo6_1+dswo6_2,
		dswo5_1+dswo5_2 = dswo7_1+dswo7_2;
	test dswo1_1+dswo1_2=0;
	test dswo5_1+dswo5_2=0;
	weight holdstd;
	

data pol_tem2;
	set pol_tem2;
	drop holdwght holdstd yresid;


















