/*creating interacted election instruments*/
/*elecdat=lev or mcc*/
%macro step2(elecdat);
data use(keep=number jid year
              y x1_1-x1_7 x2_1-x2_7 w1-w344 z1-z392);
  set %do i=1 %to 7; crime2(in=ds&i) %end; ;
  number=ds1 %do i=2 %to 7; +&i*ds&i %end; ;
  %do i=1 %to 7; nn&i=(number=&i); %end;
  v=(number in (1,2,3,4));
  p=(number in (5,6,7));
  uno=v+p;
  if number=1 then y=dlnc1;
  %do i=2 %to 7; else if number=&i then y=dlnc&i; %end;
  %do i=1 %to 7; x1_&i=dlns_1*nn&i; %end; /*x1_1-x1_7*/
  %do i=1 %to 7; x2_&i=dlns_2*nn&i; %end; /*x2_1-x2_7*/
/*City size interacted with Crime categories*/
  %do i=1 %to 7; %do j=1 %to 4; %let k=%eval( (&i-1)*4+&j );
    w&k = cs&j*nn&i; /*w1-w28*/ /*City-size x Crime*/
  %end; %end;
/*Year dummies interacted with Crime categories*/
  %do i=1 %to 7; %do j=1 %to 20; %let k=%eval( (&i-1)*20+&j+28 );
    w&k = y%eval(72+&j)*nn&i;  /*w29-w168*/ /*Year dummies x Crime*/
  %end; %end;
/*Region dummies interacted with Crime categories*/
  %do i=1 %to 7; %do j=1 %to 9; %let k=%eval( (&i-1)*9+&j+168 );
    w&k = rr&j*nn&i; /*w169-w231*/ /*Region dummies x Crime*/
  %end; %end;
/*City dummies (NOT interacted)*/
  %do j=1 %to 59; %let k=%eval( &j+231 );
    w&k = cc&j;      /*w232-w290*/  /*City indicators*/
  %end;
/*Covariates interacted with Crime Categories*/
  %do i=1 %to 7; %do j=1 %to 6; %let k=%eval( (&i-1)*6+&j+290 );
    w&k = dx&j*nn&i; /*w291-w332*/
  %end; %end;
/*Covariates interacted with violent, property*/
  %do j=1 %to 6; %let k=%eval( &j+332 );
    w&k = dx&j*v;    /*w333-w338*/
  %end;
  %do j=1 %to 6; %let k=%eval( &j+338 );
    w&k = dx&j*p;    /*w339-w344*/
  %end;
/*z1-z28:Instruments, uninteracted*/
  %if &elecdat=lev %then %do;
    %do i=1 %to 7; %let k=%eval(&i);    z&k=elec_1*nn&i; /* z1- z7*/ %end;
    %do i=1 %to 7; %let k=%eval(&i+7);  z&k=elec_2*nn&i; /* z8-z14*/ %end;
  %end;
  %if &elecdat=mcc %then %do;
    %do i=1 %to 7; %let k=%eval(&i);    z&k=may_1*nn&i; /* z1- z7*/ %end;
    %do i=1 %to 7; %let k=%eval(&i+7);  z&k=may_2*nn&i; /* z8-z14*/ %end;
  %end;
  %do i=1 %to 7; %let k=%eval(&i+14); z&k=gov_1*nn&i; /*z15-z21*/ %end;
  %do i=1 %to 7; %let k=%eval(&i+21); z&k=gov_2*nn&i; /*z22-z28*/ %end;

/*z29-z140: elections interacted with city-size indicators*/
  %do i=1 %to 28; %do j=1 %to 4; %let k=%eval( (&i-1)*4+&j+28 );
    z&k=z&i*cs&j;
  %end; %end;

/*z141-z392: elections interacted with region indicators*/
  %do i=1 %to 28; %do j=1 %to 9; %let k=%eval( (&i-1)*9+&j+140 );
    z&k=z&i*rr&j;
  %end; %end;

run;
%mend;









