/*elecdat=lev (for elec_1 elec_2)
          mcc (for may_1 may_2)
  laglen =1 (for regression of dlns_1 on stuff)
          2 (for regression of dlns_2 on stuff)
*/

%macro analyze2(elecdat,laglen,crimecat);
%let wset=y73-y92 rr1-rr9 cs1-cs4 cc1-cc59 dx1-dx6;
%let wset=y73-y92 cs1-cs4 cc1-cc59 dx1-dx6;


%if &elecdat=lev %then %let zset=elec_1 elec_2;
%if &elecdat=mcc %then %let zset=may_1 may_2;

proc syslin data=crime2(where=(nobs_&crimecat=1));
  model dlns_&laglen=&zset gov_1 gov_2 &wset;
  %if &laglen=1 %then title "laglen=1: test 4=pre,5=of";;
  %if &laglen=2 %then title "laglen=2: test 4=of,5=post";;
  test %scan(&zset,1) , %scan(&zset,2) , gov_1 , gov_2;
  test %scan(&zset,1)+gov_1=0;
  test %scan(&zset,2)+gov_2=0;
  test %scan(&zset,1) , %scan(&zset,2);
  test gov_1, gov_2;

run;
%mend;

